<?php
  session_start();
  header ("HTTP/1.1 200 OK");  
  
  if (isset($_GET["type"])){
      $type = @$_GET["type"];
  }
  if (isset($_GET["group"])){
      $group = @$_GET["group"];
  }  
  if (isset($_GET["fromdate"])){
      $fromdate = @$_GET["fromdate"];
  } 
  if (isset($_GET["todate"])){
      $todate = @$_GET["todate"];
  }       

  $conn = new PDO("sqlite:/var/local/data/capeclock.db");
  $sql = "SELECT id, \"desc\", enabled, initialised, log, setip, dhcp, ip, netmask, broadcast, gateway, nameserver1, nameserver2, nameserver3, nameserver4, sip, sport, ssip, ssport, sson, 
          cip, cport, csip, csport, cson, smtpip, smtpport, smtpuser, smtppass, idletimeout, connectiontimeout, retryclientconnect, keepclockings, autoreader, maxunknowncards, internettimeonboot, 
          internettimeserver1, internettimeserver2, internettimeserver3, internettimeserver4, internettimeserver5, internettimeserver6, tz_new, tz_current, defaultmodel, waitidealmin, waitmax, countidealmin, 
          countmax, timepriority, hrsindec, dateformat, advancedhw FROM thisdev";
  $res = $conn->query($sql) or die('<br/>Error in qeury string:<br/>' .$sql .'<br/>');
  $row = $res->fetch(PDO::FETCH_ASSOC);
  reset($row);
  $_SESSION["hrsindec"] = $row["hrsindec"];
  $_SESSION["dateformat"] = $row["dateformat"];
  if($row["dateformat"] == 2){$_SESSION["dateformatpic"] = "m/d/Y";
  }elseif($row["dateformat"] == 6){$_SESSION["dateformatpic"] = "d/m/Y";
  }elseif($row["dateformat"] == 10){$_SESSION["dateformatpic"] = "Y/m/d";
  }  

  $conn = new PDO("sqlite:/var/local/data/capeclock.db");
  $sql = "SELECT id, autoproc, cat1, cat2, cat3, cat4, cat5, cat6, cat7, cat8, cat9, balancing, rounding, extracat, normalcat, overtimecat, satcat, suncat, holidaycat, variancecat,
          sunday, monday, tuesday, wednesday, thursday, friday, saturday, leaveautoapproved, rounding, runningtotals FROM gloproc";
  $res = $conn->query($sql) or die('<br/>Error in qeury string:<br/>' .$sql .'<br/>');    
  $row = $res->fetch(PDO::FETCH_ASSOC);
  reset($row);
  if ($row["autoproc"] == 1 || $row["autoproc"] == 3){$_SESSION["autoproc"] = 1;} else {$_SESSION["autoproc"] = 0;}
  $_SESSION["leaveautoapproved"] = $row["leaveautoapproved"];
  $_SESSION["rounding"] = $row["rounding"];
  $_SESSION["runningtotals"] = $row["runningtotals"];
  $_SESSION["cat1"] = $row["cat1"];
  $_SESSION["cat2"] = $row["cat2"];
  $_SESSION["cat3"] = $row["cat3"];
  $_SESSION["cat4"] = $row["cat4"];
  $_SESSION["cat5"] = $row["cat5"];
  $_SESSION["cat6"] = $row["cat6"];
  $_SESSION["cat7"] = $row["cat7"];
  $_SESSION["cat8"] = $row["cat8"];
  $_SESSION["cat9"] = $row["cat9"];      
  
  switch ($type) {
  case "employees":
    exportemployees();
    break;
  case "clockings":
    exportclockings();
    break;
  case "cards":
    exportcards();
    break;
  case "dailyhours":
    exportdhours();
    break;
  case "procdailyhours":    
    exportdprochours();
    break;
  case "payrollhours":
    exportphours();
    break;        
  case "procpayrollhours":
    exportpprochours();
    break;            
  }

function exportemployees()
{   
    $conn = new PDO("sqlite:/var/local/data/capeclock.db");
    //$sql = "SELECT en as 't1.en', enint as 't1.enint', t1.pc as 't1.pc', dn as 't1.dn', fn as 't1.fn', ln as 't1.ln', su as 't1.su', admin as 't1.admin', pass as 't1.pass', deptid as 't1.deptid', \"desc\" AS 'lp_deptid', exdate as 't1.exdate', paycycle as 't1.paycycle', disflexi as 't1.disflexi', flexih as 't1.flexih', flexim as 't1.flexim', carea as 't1.carea', cstat as 't1.cstat', asu as 't1.asu', dm as 't1.dm', dme as 't1.dme', careatime as 't1.careatime', cstattime as 't1.cstattime' FROM emp AS t1 LEFT OUTER JOIN dept AS t2 ON (t1.deptid = t2.id)";  
    $sql = $_SESSION["currentbrowseselect"];
    $res = $conn->query($sql) or die('<br/>Error in qeury string:<br/>' .$sql .'<br/>');
    header("Cache-Control: no-cache, must-revalidate"); 
    header('Content-Type: text/csv');
    header('Content-Disposition: inline; filename="employees.csv" ');
    header('Content-Transfer-Encoding: text');
    $stringdata = "No,Surname, First Name,Department,Termination Date\n";
    echo $stringdata; 
    while ($row = $res->fetch(PDO::FETCH_ASSOC)){
    unset($stringdata);
    if ($row["t1.exdate"] == 0) {$locexdate="";} else {$locexdate=gmdate($_SESSION["dateformatpic"], ($row["t1.exdate"]));}
    $stringdata = trim($row["t1.en"]) ."," .trim($row["t1.ln"]) ."," .trim($row["t1.fn"]) ."," .trim($row["lp_deptid"]) ."," .$locexdate ."\n";
    echo $stringdata;  
    }
}

function exportclockings()
{
    global $fromdate;
    global $todate;
    global $group;
    if (isset($group)){$group = " and t1.en ='" . $group ."'";}
    $conn = new PDO("sqlite:/var/local/data/capeclock.db");    
    //$sql = "SELECT id as 't1.id', t1.pc as 't1.pc', pr as 't1.pr', t as 't1.t', ot as 't1.ot', gd as 't1.gd', t1.en as 't1.en', ln as 't2.ln', fn as 't2.fn', ty as 't1.ty', ds as 't1.ds'
    //        , r as 't1.r', aid as 't1.aid', stat as 't1.stat', cn as 't1.cn', scn as 't1.scn', del as 't1.del' FROM clocking AS t1 LEFT OUTER JOIN emp AS t2 ON (t1.en = t2.en) where t1.t >= "
    //        .string2date(1, 0, 0, 0, $fromdate, 0) ." and t1.t <= ".string2date(1, 23, 59, 59, $todate, 0) .$group ." and (t1.ty = 0 or (t1.ty >= 80 and t1.ty <= 99)) and (t1.del = 0 or t1.del is null) order by 't1.t' desc";
    $sql = $_SESSION["currentbrowseselect"];
    $res = $conn->query($sql) or die('<br/>Error in qeury string:<br/>' .$sql .'<br/>');
    header("Cache-Control: no-cache, must-revalidate"); 
    header('Content-Type: text/csv');
    header('Content-Disposition: inline; filename="clockings.csv" ');
    header('Content-Transfer-Encoding: text');    
    $stringdata = "Date,Time,No, Surname, First Name,Type,Extender,Reader,Area,In/Out,Card No\n";
    echo $stringdata; 
    while ($row = $res->fetch(PDO::FETCH_ASSOC)){
    unset($stringdata);      
    if($row["t1.ty"] == "0"){
        $eventtype = "Clock";
    } elseif ($row["t1.ty"] == "1"){
        $eventtype = "USB";
    } elseif ($row["t1.ty"] == "98"){
        $eventtype = "Changed";
    } elseif ($row["t1.ty"] == "99"){
        $eventtype = "Manual";
    } else{
        $eventtype = "Clock";
    }            
    $stringdata = gmdate($_SESSION["dateformatpic"], ($row['t1.t'])) ."," .gmdate("H:i:s", ($row['t1.t'])) ."," .trim($row["t1.en"]) ."," .trim($row["t2.ln"]) .","  .trim($row["t2.fn"]) ."," .$eventtype ."," .trim($row["t1.ds"]) ."," .trim($row["t1.r"]) ."," .trim($row["t1.aid"]) ."," .trim($row["t1.stat"]) ."," .trim($row["t1.scn"]) ."\n";
    echo $stringdata;  
    }    
}   

function exportcards()
{  
    global $group;
    $conn = new PDO("sqlite:/var/local/data/capeclock.db");
    if (isset($group)){$group = " and t1.en ='" . $group ."'";}     
    //$sql = "SELECT t1.lcn as 't1.lcn', t1.ecn as 't1.ecn', t1.scn as 't1.scn', t1.en as 't1.en', t2.ln as 't2.ln', t2.fn as 't2.fn', t1.pc as 't1.pc', t1.cnv as 't1.cnv', t1.asu as 't1.asu', t1.seqid as 't1.seqid' FROM card as t1 LEFT OUTER JOIN emp AS t2 ON (t1.en = t2.en) where t1.seqid >= 0" .$group ." order by 't1.t' desc";  
    $sql = $_SESSION["currentbrowseselect"];
    $res = $conn->query($sql) or die('<br/>Error in qeury string:<br/>' .$sql .'<br/>');
    header("Cache-Control: no-cache, must-revalidate"); 
    header('Content-Type: text/csv');
    header('Content-Disposition: inline; filename="cards.csv" ');
    header('Content-Transfer-Encoding: text');
    $stringdata = "Cards No,Emp No,Surname,First Name\n";
    echo $stringdata; 
    while ($row = $res->fetch(PDO::FETCH_ASSOC)){
    unset($stringdata);
    if ($row["exdate"] == 0) {$locexdate="";} else {$locexdate=gmdate($_SESSION["dateformatpic"], ($row["exdate"]));}
    $stringdata = trim($row["t1.lcn"]) ."," .trim($row["t1.en"]) ."," .trim($row["t2.ln"]) ."," .trim($row["t2.fn"]) ."\n";
    echo $stringdata;  
    }
}

function exportdhours() 
{
    global $fromdate;
    global $todate;
    global $group;
    if (isset($group)){$group = " and t1.en ='" . $group ."'";}     
    $conn = new PDO("sqlite:/var/local/data/capeclock.db");
    //$sql = "SELECT id as 't1.id', t1.pc as 't1.pc', pr as 't1.pr', t as 't1.t', ot as 't1.ot', gd as 't1.gd', t1.en as 't1.en', ln as 't2.ln', fn as 't2.fn', ty as 't1.ty', ds as 't1.ds'
    //       , r as 't1.r', aid as 't1.aid', stat as 't1.stat', cn as 't1.cn', scn as 't1.scn', del as 't1.del' FROM clocking AS t1 LEFT OUTER JOIN emp AS t2 ON (t1.en = t2.en) 
    //        where t1.t >= " .string2date(1, 0, 0, 0, $fromdate, 0) .$group 
    //        ." and t1.t <=" .string2date(1, 23, 59, 59, $todate, 0)
    //        ." and (t1.ty = 0 or (t1.ty >= 80 and t1.ty <= 99)) and (t1.del = 0 or t1.del is null) order by  \"" ."t1.en" ."\"asc, \"" ."t1.t" ."\"asc";  
    $sql = $_SESSION["currentbrowseselect"];
    $res = $conn->query($sql) or die('<br/>Error in qeury string:<br/>' .$sql .'<br/>');
    header("Cache-Control: no-cache, must-revalidate"); 
    header('Content-Type: text/csv');
    header('Content-Disposition: inline; filename="dailyhours.csv" ');
    header('Content-Transfer-Encoding: text');
    $stringdata = "Date,Emp No,Surname,First Name,Clockings,Hours\n";
    echo $stringdata; 
      $setchecks = 1;      
      while ($row = $res->fetch(PDO::FETCH_ASSOC))
      {          
          if ($setchecks == 1) {
              $curemp = $row['t1.en'];
              $curdate = gmdate($_SESSION["dateformatpic"], ($row['t1.t']));                      
              $curfn = $row['t2.fn'];
              $curln = $row['t2.ln'];                       
              $setchecks = 0;
          }                  
          if ($curemp != $row['t1.en'] || $curdate != gmdate($_SESSION["dateformatpic"], ($row['t1.t']))){
              if ($laststat == "0"){ 

              $style = "fr";
              if ($st % 2 != 0) {
                $style = "sr";}
              $st += 1;
              
              for ($d = 0; $d < count($daydata); $d++)
              {
                $clkno += 1;
                if ($clockings == "" || (!isset($clockings))) {
                    $clockings = htmlspecialchars($daydata[$d]["t1.stat"] ? "I-" : "O-") .(gmdate("H:i", ($daydata[$d]['t1.t']))) ." " ;
                }else {
                    $clockings .= htmlspecialchars($daydata[$d]["t1.stat"] ? "I-" : "O-") .(gmdate("H:i", ($daydata[$d]['t1.t']))) ." " ;
                }
                if ($clkno == 1 && $daydata[$d]["t1.stat"] == "0"){"do nothing";}
                else{
                    if($daydata[$d]["t1.stat"] == "0" && ($prevclkstat == "0" || $prevclkstat == "" || !isset($prevclkstat) )){"do nothing";}
                    else{
                        if ($daydata[$d]["t1.stat"] == "1"){
                            $thrs = intval(($daydata[$d]["t1.t"]) / 3600);
                            $tmin = intval((($daydata[$d]["t1.t"]) % 3600)/60);                                    
                            $prevclktime = ($thrs*3600) + ($tmin*60);
                            $prevclkstat = $daydata[$d]["t1.stat"];
                            $prevclkstat = $daydata[$d]["t1.stat"];
                        }else{
                            $thrs = intval(($daydata[$d]["t1.t"]) / 3600);
                            $tmin = intval((($daydata[$d]["t1.t"]) % 3600)/60);                                    
                            $totalhours = $totalhours + ((($thrs*3600) + ($tmin*60))-intval($prevclktime));                    
                            $prevclkstat = $daydata[$d]["t1.stat"];
                        }
                    }
                }
                                                                
              }
              $tothrs = intval($totalhours / 3600);
              $padmin = strlen(intval(($totalhours % 3600)/60));
              if ($padmin == 1){$totalmin = "0" .intval(($totalhours % 3600)/60);}else{$totalmin = intval(($totalhours % 3600)/60);}                        
              if ($_SESSION["hrsindec"] == 0) {
                  $disphrstotal = $tothrs.":" .$totalmin;
              } else {
                      $totaldecmin = round(($totalmin/60),2) * 100;
                      if(strlen($totaldecmin) == 1){$totaldecmin = "0" .trim($totaldecmin);}
                      $disphrstotal = $tothrs."." .$totaldecmin;
              }
              
              unset($stringdata);              
              $stringdata = $curdate ."," .$curemp ."," .$curln ."," .$curfn ."," .$clockings ."," .$disphrstotal ."\n";
              echo $stringdata;
              
              $curemp = $row['t1.en'];
              $curfn = $row['t2.fn'];
              $curln = $row['t2.ln']; 
              $curdate = gmdate($_SESSION["dateformatpic"], ($row['t1.t']));
              
              $clockings = "";
              $totalhours = 0;
              $prevclktime = "";
              $prevclkstat = "";
              $clkno = 0;                      
              unset($daydata);                      
          }else{if($curemp != $row['t1.en']){
              
              $curemp = $row['t1.en'];
              $curfn = $row['t2.fn'];
              $curln = $row['t2.ln']; 
              $curdate = gmdate($_SESSION["dateformatpic"], ($row['t1.t']));
              
              $clockings = "";                      
              $totalhours = 0;
              $prevclktime = "";
              $prevclkstat = "";
              $clkno = 0;                      
              unset($daydata);                                            
              }
              }                  
          }                  
          $daydata[] = $row;
          $laststat = $row['t1.stat'];                  
          
      }
      if ($laststat == "0"){ 

      $style = "fr";
      if ($st % 2 != 0) {
        $style = "sr";}
      $st += 1;
      
      for ($d = 0; $d < count($daydata); $d++)
      {
        $clkno += 1;
        if ($clockings == "" || (!isset($clockings))) {
            $clockings = htmlspecialchars($daydata[$d]["t1.stat"] ? "I-" : "O-") .(gmdate("H:i", ($daydata[$d]['t1.t']))) ." " ;
        }else {
            $clockings .= htmlspecialchars($daydata[$d]["t1.stat"] ? "I-" : "O-") .(gmdate("H:i", ($daydata[$d]['t1.t']))) ." " ;
        }
        if ($clkno == 1 && $daydata[$d]["t1.stat"] == "0"){"do nothing";}
        else{
            if($daydata[$d]["t1.stat"] == "0" && ($prevclkstat == "0" || $prevclkstat == "" || !isset($prevclkstat) )){"do nothing";}
            else{
                if ($daydata[$d]["t1.stat"] == "1"){                    
                    $thrs = intval(($daydata[$d]["t1.t"]) / 3600);
                    $tmin = intval((($daydata[$d]["t1.t"]) % 3600)/60);                                    
                    $prevclktime = ($thrs*3600) + ($tmin*60);
                    $prevclkstat = $daydata[$d]["t1.stat"];
                    $prevclkstat = $daydata[$d]["t1.stat"];
                }else{
                    $thrs = intval(($daydata[$d]["t1.t"]) / 3600);
                    $tmin = intval((($daydata[$d]["t1.t"]) % 3600)/60);                                    
                    $totalhours = $totalhours + ((($thrs*3600) + ($tmin*60))-intval($prevclktime));                    
                    $prevclkstat = $daydata[$d]["t1.stat"];
                }
            }
        }
                                                        
      }
      $tothrs = intval($totalhours / 3600);
      $padmin = strlen(intval(($totalhours % 3600)/60));
      if ($padmin == 1){$totalmin = "0" .intval(($totalhours % 3600)/60);}else{$totalmin = intval(($totalhours % 3600)/60);}                        
      if ($_SESSION["hrsindec"] == 0) {
          $disphrstotal = $tothrs.":" .$totalmin;
      } else {
              $totaldecmin = round(($totalmin/60),2) * 100;
              if(strlen($totaldecmin) == 1){$totaldecmin = "0" .trim($totaldecmin);}
              $disphrstotal = $tothrs."." .$totaldecmin;
      }
      
      unset($stringdata);
      $stringdata = $curdate ."," .$curemp ."," .$curln ."," .$curfn ."," .$clockings ."," .$disphrstotal ."\n";
      echo $stringdata;
      
      $curemp = $row['t1.en'];
      $curfn = $row['t2.fn'];
      $curln = $row['t2.ln']; 
      $curdate = gmdate($_SESSION["dateformatpic"], ($row['t1.t']));
      
      $clockings = "";
      $totalhours = 0;
      $prevclktime = "";
      $prevclkstat = "";
      $clkno = 0;                      
      unset($daydata);                      
  }      
}

function exportdprochours()
{   
    global $fromdate;
    global $todate;
    global $group; 
    if (isset($group)){$group = " and t1.en ='" . $group ."'";}   
    $conn = new PDO("sqlite:/var/local/data/capeclock.db");
    //$sql = "SELECT t1.id as 't1.id', t1.processed as 't1.processed', t1.en as 't1.en', t2.en as 't2.en', t2.fn as 't2.fn', t2.ln as 't2.ln', t1.date as 't1.date', t1.desc as 't1.desc',
    //       t1.hours1 as 't1.hours1', t1.hours2 as 't1.hours2', t1.hours3 as 't1.hours3', t1.hours4 as 't1.hours4', t1.hours5 as 't1.hours5', t1.hours6 as 't1.hours6', t1.hours7 as 't1.hours7',
    //       t1.hours8 as 't1.hours8', t1.hours9 as 't1.hours9', t1.orhours1 as 't1.orhours1', t1.orhours2 as 't1.orhours2', t1.orhours3 as 't1.orhours3', t1.orhours4 as 't1.orhours4',
    //       t1.orhours5 as 't1.orhours5', t1.orhours6 as 't1.orhours6', t1.orhours7 as 't1.orhours7',t1.orhours8 as 't1.orhours8', t1.orhours9 as 't1.orhours9', t1.lunch as 't1.lunch',
    //       t1.orlunch as 't1.orlunch', t1.suen as 't1.suen', t1.stime as 't1.stime', t1.clockings as 't1.clockings',
    //       t1.awol as 't1.awol', t1.expected as 't1.expected', t1.comment as 't1.comment', t1.runningtotal as 't1.runningtotal' FROM hour as t1 LEFT OUTER JOIN emp AS t2 ON (t1.en = t2.en)";    
    //$sql .= " where t1.date >= " .string2date(1, 0, 0, 0, $fromdate, 0) ." and t1.date <= " .string2date(1, 23, 59, 59, $todate, 0); 
    //$sql .= " order by \"" ."t1.en" ."\"";
    $sql = $_SESSION["currentbrowseselect"];
    $res = $conn->query($sql) or die('<br/>Error in qeury string:<br/>' .$sql .'<br/>');
    header("Cache-Control: no-cache, must-revalidate"); 
    header('Content-Type: text/csv');
    header('Content-Disposition: inline; filename="dailyhours.csv" ');
    header('Content-Transfer-Encoding: text');    
    $stringdata = "Date, Emp No,Surname, First Name, Day, Clockings,".$_SESSION["cat1"].",".$_SESSION["cat2"].",".$_SESSION["cat3"].",".$_SESSION["cat4"].",".$_SESSION["cat5"]
                    .",".$_SESSION["cat6"].",".$_SESSION["cat7"].",".$_SESSION["cat8"].",".$_SESSION["cat9"].","."Lunch".",";
    if($_SESSION["runningtotals"] == 1){$stringdata = $stringdata ."Running Total";}
    $stringdata = $stringdata ."\n";
    echo $stringdata;     
    unset($stringdata);
    while ($row = $res->fetch(PDO::FETCH_ASSOC)){
        if($row["t1.orhours1"] == -1){$dhours1 = $row["t1.hours1"];}else{$dhours1 = $row["t1.orhours1"];}
        if($row["t1.orhours2"] == -1){$dhours2 = $row["t1.hours2"];}else{$dhours2 = $row["t1.orhours2"];}
        if($row["t1.orhours3"] == -1){$dhours3 = $row["t1.hours3"];}else{$dhours3 = $row["t1.orhours3"];}
        if($row["t1.orhours4"] == -1){$dhours4 = $row["t1.hours4"];}else{$dhours4 = $row["t1.orhours4"];}
        if($row["t1.orhours5"] == -1){$dhours5 = $row["t1.hours5"];}else{$dhours5 = $row["t1.orhours5"];}
        if($row["t1.orhours6"] == -1){$dhours6 = $row["t1.hours6"];}else{$dhours6 = $row["t1.orhours6"];}                    
        if($row["t1.orhours7"] == -1){$dhours7 = $row["t1.hours7"];}else{$dhours7 = $row["t1.orhours7"];}
        if($row["t1.orhours8"] == -1){$dhours8 = $row["t1.hours8"];}else{$dhours8 = $row["t1.orhours8"];}
        if($row["t1.orhours9"] == -1){$dhours9 = $row["t1.hours9"];}else{$dhours9 = $row["t1.orhours9"];}
        if($row["t1.orlunch"] == -1){$dlunch = $row["t1.lunch"];}else{$dlunch = $row["t1.orlunch"];}
        $rtotal = $row["t1.runningtotal"];

        $stringdata = date($_SESSION["dateformatpic"], $row["t1.date"]).",".$row["t1.en"].",".$row["t2.ln"].",".$row["t2.fn"].",".$row["t1.desc"].",".$row["t1.clockings"]
        .",".formatsec2str($dhours1,1).",".formatsec2str($dhours2,1).",".formatsec2str($dhours3,1)
        .",".formatsec2str($dhours4,1).",".formatsec2str($dhours5,1).",".formatsec2str($dhours6,1)
        .",".formatsec2str($dhours7,1).",".formatsec2str($dhours8,1).",".formatsec2str($dhours9,1) 
        .",".formatsec2str($dlunch,1) .",";
        if($_SESSION["runningtotals"] == 1){$stringdata = $stringdata .formatsec2str($rtotal,1);}
        $stringdata = $stringdata ."\n";
        echo $stringdata;         
    }    
}

function exportphours()
{   
    global $fromdate;
    global $todate;
    global $group; 
    if (isset($group)){$group = " and t1.en ='" . $group ."'";}   
    $conn = new PDO("sqlite:/var/local/data/capeclock.db");
    //$sql = "SELECT id as 't1.id', t1.pc as 't1.pc', pr as 't1.pr', t as 't1.t', ot as 't1.ot', gd as 't1.gd', t1.en as 't1.en', ln as 't2.ln', fn as 't2.fn', ty as 't1.ty', ds as 't1.ds'
    //        , r as 't1.r', aid as 't1.aid', stat as 't1.stat', cn as 't1.cn', scn as 't1.scn', del as 't1.del' FROM clocking AS t1 LEFT OUTER JOIN emp AS t2 ON (t1.en = t2.en) where t1.t >= "            
    //        .string2date(1, 0, 0, 0, $fromdate, 0) .$group ." and t1.t <= " .string2date(1, 23, 59, 59, $todate, 0)
    //        ." and (t1.ty = 0 or (t1.ty >= 80 and t1.ty <= 99)) and (t1.del = 0 or t1.del is null) order by  \"" ."t1.en" ."\"asc, \"" ."t1.t" ."\"asc";  
    $sql = $_SESSION["currentbrowseselect"];
    $res = $conn->query($sql) or die('<br/>Error in qeury string:<br/>' .$sql .'<br/>');
    header("Cache-Control: no-cache, must-revalidate"); 
    header('Content-Type: text/csv');
    header('Content-Disposition: inline; filename="payrollhours.csv" ');
    header('Content-Transfer-Encoding: text');    
    $stringdata = "Emp No,Surname,First Name,";    
    $x = LdateDiff($fromdate, $todate);
    for ($y = 0; $y < $x; $y++){            
        $columndate = string2date(1, 0, 0, 0, $fromdate, ($y*86400));
        $stringdata = $stringdata .gmdate("D d/m", $columndate) .",";
    }
    $stringdata = $stringdata ."Hours\n";                
    echo $stringdata;     
    unset($stringdata);
        
     $setchecks = 1;
     while ($row = $res->fetch(PDO::FETCH_ASSOC))
     {
          if ($setchecks == 1) {
              $curemp = $row['t1.en'];
              $curdate = gmdate($_SESSION["dateformatpic"], ($row['t1.t']));                      
              $curfn = $row['t2.fn'];
              $curln = $row['t2.ln'];                       
              $setchecks = 0;
          }                            
              
          if ($curemp != $row['t1.en']){
                    
              if ($laststat == "0" || $laststat == "1"){                                           
              for ($d = 0; $d < count($daydata); $d++)
              {
                if ($clkno == 1 && $daydata[$d]["t1.stat"] == "0"){"do nothing";}
                else{
                    if($daydata[$d]["t1.stat"] == "0" && ($prevclkstat == "0" || $prevclkstat == "" || !isset($prevclkstat) )){"do nothing";}
                    else{
                        if ($daydata[$d]["t1.stat"] == "1" && ($daydata[$d]["t1.t"] <= string2date(1, 23, 59, 59, $todate, 0))){                        
                            $thrs = intval(($daydata[$d]["t1.t"]) / 3600);
                            $tmin = intval((($daydata[$d]["t1.t"]) % 3600)/60);                                    
                            $prevclktime = ($thrs*3600) + ($tmin*60);
                            $prevclkstat = $daydata[$d]["t1.stat"];
                            $prevclkstat = $daydata[$d]["t1.stat"];
                        }else if(($daydata[$d]["t1.t"] <= string2date(1, 23, 59, 59, $todate, 0)) ||
                            ($daydata[$d]["t1.t"] >= string2date(1, 23, 59, 59, $todate, 0)) && $prevclkstat == "1"){                                                    
                            $thrs = intval(($daydata[$d]["t1.t"]) / 3600);
                            $tmin = intval((($daydata[$d]["t1.t"]) % 3600)/60);                                    
                            $totalhours = $totalhours + ((($thrs*3600) + ($tmin*60))-intval($prevclktime));                    
                            $prevclkstat = $daydata[$d]["t1.stat"];
                        }
                    }
                }
                if (isset($daydate) && $daydate != gmdate($_SESSION["dateformatpic"], ($daydata[$d]['t1.t']))){                       
                    $v =  LdateDiff($fromdate, $daydate) - 1;
                    $dailyhours = $totalhours - $lasttotalhours;                            
                    $dayhrs = intval($dailyhours / 3600);
                    $padmin = strlen(intval(($dailyhours % 3600)/60));
                    if ($padmin == 1){$daymin = "0" .intval(($dailyhours % 3600)/60);}else{$daymin = intval(($dailyhours % 3600)/60);}
                      if ($_SESSION["hrsindec"] == 0) {
                          $dispdayhrs = $dayhrs.":" .$daymin;
                      } else {
                              $daydecmin = round(($daymin/60),2) * 100;
                              if(strlen($daydecmin) == 1){$daydecmin = "0" .trim($daydecmin);}
                              $dispdayhrs = $dayhrs ."." .$daydecmin;
                      }              
                    $payrolldhours[$v] = $dispdayhrs;
                    $lasttotalhours = $totalhours;
                }                        
                $daydate = gmdate($_SESSION["dateformatpic"], ($daydata[$d]['t1.t']));                                                                            
              }
              //Daily Hours
              $v =  LdateDiff($fromdate, $daydate) - 1;              
              $dailyhours = $totalhours - $lasttotalhours;                        
              $dayhrs = intval($dailyhours / 3600);
              $padmin = strlen(intval(($dailyhours % 3600)/60));
              if ($padmin == 1){$daymin = "0" .intval(($dailyhours % 3600)/60);}else{$daymin = intval(($dailyhours % 3600)/60);}
              if ($_SESSION["hrsindec"] == 0) {
                  $dispdayhrs = $dayhrs.":" .$daymin;
              } else {
                      $daydecmin = round(($daymin/60),2) * 100;
                      if(strlen($daydecmin) == 1){$daydecmin = "0" .trim($daydecmin);}
                      $dispdayhrs = $dayhrs ."." .$daydecmin;
              } 
                                    
              $payrolldhours[$v] = $dispdayhrs;
             
              //Total Hours
              $tothrs = intval($totalhours / 3600);
              $padmin = strlen(intval(($totalhours % 3600)/60));
              if ($padmin == 1){$totalmin = "0" .intval(($totalhours % 3600)/60);}else{$totalmin = intval(($totalhours % 3600)/60);}                        
              if ($_SESSION["hrsindec"] == 0) {
                  $disphrstotal = $tothrs.":" .$totalmin;
              } else {
                      $totaldecmin = round(($totalmin/60),2) * 100;
                      if(strlen($totaldecmin) == 1){$totaldecmin = "0" .trim($totaldecmin);}
                      $disphrstotal = $tothrs."." .$totaldecmin;
              }
              $stringdata = $curemp ."," .$curln .","  .$curfn .",";
                for ($y = 0; $y < $x; $y++){
                    $stringdata = $stringdata .$payrolldhours[$y] .",";
                }
              $stringdata = $stringdata . $disphrstotal ."\n";
              echo $stringdata;
              
              //DailyHoursresets
              $dailyhours = 0;
              $lasttotalhours = 0;
              $dispdayhrs = "";
              unset($daydate);
              unset($payrolldhours);
              
              //TotalHourResets
              $curemp = $row['t1.en'];
              $curfn = $row['t2.fn'];
              $curln = $row['t2.ln']; 
              $curdate = gmdate($_SESSION["dateformatpic"], ($row['t1.t']));
              
              $clockings = "";
              $totalhours = 0;
              $prevclktime = "";
              $prevclkstat = "";
              $clkno = 0;                      
              unset($daydata);
                                    
          }else{if($curemp != $row['t1.en']){
              
              $curemp = $row['t1.en'];
              $curfn = $row['t2.fn'];
              $curln = $row['t2.ln']; 
              $curdate = gmdate($_SESSION["dateformatpic"], ($row['t1.t']));
              
              $clockings = "";                      
              $totalhours = 0;
              $prevclktime = "";
              $prevclkstat = "";
              $clkno = 0;                      
              unset($daydata);                                            
              }
              }                  
          }
          $daydata[] = $row;
          $laststat = $row['t1.stat'];


          
      }
      for ($d = 0; $d < count($daydata); $d++)
      {
        if ($clkno == 1 && $daydata[$d]["t1.stat"] == "0"){"do nothing";}
        else{
            if($daydata[$d]["t1.stat"] == "0" && ($prevclkstat == "0" || $prevclkstat == "" || !isset($prevclkstat) )){"do nothing";}
            else{
                if ($daydata[$d]["t1.stat"] == "1"){
                    $thrs = intval($daydata[$d]["t1.t"] / 3600);
                    $tmin = intval(($daydata[$d]["t1.t"] % 3600)/60);                                    
                    $prevclktime = ($thrs*3600) + ($tmin*60);
                    $prevclkstat = $daydata[$d]["t1.stat"];
                    $prevclkstat = $daydata[$d]["t1.stat"];
                }else{
                    $thrs = intval($daydata[$d]["t1.t"] / 3600);
                    $tmin = intval(($daydata[$d]["t1.t"] % 3600)/60);                                    
                    $totalhours = $totalhours + ((($thrs*3600) + ($tmin*60))-intval($prevclktime));                    
                    $prevclkstat = $daydata[$d]["t1.stat"];
                }
            }
        }
        if (isset($daydate) && $daydate != gmdate($_SESSION["dateformatpic"], ($daydata[$d]['t1.t']))){                       
            $v =  LdateDiff($fromdate, $daydate) - 1;
            $dailyhours = $totalhours - $lasttotalhours;                            
            $dayhrs = intval($dailyhours / 3600);
            $padmin = strlen(intval(($dailyhours % 3600)/60));
            if ($padmin == 1){$daymin = "0" .intval(($dailyhours % 3600)/60);}else{$daymin = intval(($dailyhours % 3600)/60);}
              if ($_SESSION["hrsindec"] == 0) {
                  $dispdayhrs = $dayhrs.":" .$daymin;
              } else {
                      $daydecmin = round(($daymin/60),2) * 100;
                      if(strlen($daydecmin) == 1){$daydecmin = "0" .trim($daydecmin);}
                      $dispdayhrs = $dayhrs ."." .$daydecmin;
              }              

            $payrolldhours[$v] = $dispdayhrs;
            $lasttotalhours = $totalhours;
        }                        
        $daydate = gmdate($_SESSION["dateformatpic"], ($daydata[$d]['t1.t']));                                                                            
      }
      //Daily Hours
      $v =  LdateDiff($fromdate, $daydate) - 1;              
      $dailyhours = $totalhours - $lasttotalhours;                        
      $dayhrs = intval($dailyhours / 3600);
      $padmin = strlen(intval(($dailyhours % 3600)/60));
      if ($padmin == 1){$daymin = "0" .intval(($dailyhours % 3600)/60);}else{$daymin = intval(($dailyhours % 3600)/60);}
              if ($padmin == 1){$daymin = "0" .intval(($dailyhours % 3600)/60);}else{$daymin = intval(($dailyhours % 3600)/60);}
              if ($_SESSION["hrsindec"] == 0) {
                  $dispdayhrs = $dayhrs.":" .$daymin;
              } else { 
                      $daydecmin = round(($daymin/60),2) * 100;
                      if(strlen($daydecmin) == 1){$daydecmin = "0" .trim($daydecmin);}
                      $dispdayhrs = $dayhrs ."." .$daydecmin;
              }              
      $payrolldhours[$v] = $dispdayhrs;

      //Total Hours
      $tothrs = intval($totalhours / 3600);
      $padmin = strlen(intval(($totalhours % 3600)/60));
      if ($padmin == 1){$totalmin = "0" .intval(($totalhours % 3600)/60);}else{$totalmin = intval(($totalhours % 3600)/60);}                        
      if ($_SESSION["hrsindec"] == 0) {
          $disphrstotal = $tothrs.":" .$totalmin;
      } else {
              $totaldecmin = round(($totalmin/60),2) * 100;
              if(strlen($totaldecmin) == 1){$totaldecmin = "0" .trim($totaldecmin);}
              $disphrstotal = $tothrs."." .$totaldecmin;
      }
      $stringdata = $curemp ."," .$curln .","  .$curfn .",";
        for ($y = 0; $y < $x; $y++){
            $stringdata = $stringdata .$payrolldhours[$y] .",";
        }
      $stringdata = $stringdata . $disphrstotal ."\n";
      echo $stringdata;              

}

function exportpprochours(){   
    $payrollhours = $_SESSION["sendtopayrollhours"];
    header("Cache-Control: no-cache, must-revalidate"); 
    header('Content-Type: text/csv');
    header('Content-Disposition: inline; filename="payrollhours.csv" ');
    header('Content-Transfer-Encoding: text');    
    $stringdata = "Date, Emp No,Surname, First Name,".$_SESSION["cat1"].",".$_SESSION["cat2"].",".$_SESSION["cat3"].",".$_SESSION["cat4"].",".$_SESSION["cat5"]
                    .",".$_SESSION["cat6"].",".$_SESSION["cat7"].",".$_SESSION["cat8"].",".$_SESSION["cat9"].",";
    if($_SESSION["runningtotals"] == 1){$stringdata = $stringdata ."Running Total";}
    $stringdata = $stringdata ."\n";
    echo $stringdata;     
    unset($stringdata);
    
   for ($i = 0; $i < count($payrollhours); $i++){
        
        if($payrollhours[$i]["payid"] != ""){
            $emppaynumber = $payrollhours[$i]["paynumber"];
        } else {
            $emppaynumber = $payrollhours[$i]["empnumber"];
        }
        $stringdata = $todate.",".$emppaynumber.",".$payrollhours[$i]['empsurname'].",".$payrollhours[$i]['empname'].",".formatsec2str($payrollhours[$i]['phours1'],1)
                      .",".formatsec2str($payrollhours[$i]['phours2'],1).",".formatsec2str($payrollhours[$i]['phours3'],1)
                      .",".formatsec2str($payrollhours[$i]['phours4'],1).",".formatsec2str($payrollhours[$i]['phours5'],1)
                      .",".formatsec2str($payrollhours[$i]['phours6'],1).",".formatsec2str($payrollhours[$i]['phours7'],1)
                      .",".formatsec2str($payrollhours[$i]['phours8'],1).",".formatsec2str($payrollhours[$i]['phours9'],1)
                      .",";
                      if($_SESSION["runningtotals"] == 1){$stringdata = $stringdata .formatsec2str($payrollhours[$i]['runningtotal'],1);}
                      $stringdata = $stringdata ."\n";
                      echo $stringdata;
   }       
}


function LdateDiff($start, $end) {
    $start_ts = string2date(1, 0, 0, 0, $start, 0);    
    $end_ts = string2date(1, 23, 59, 59, $end, 0);
    $diff = $end_ts - $start_ts;
    return round($diff / 86400);
}

function string2date($gm, $hour, $min, $sec, $sdate, $offset) {
    $arr_date = explode("/", $sdate);
    if(!isset($arr_date[2])){$rob="hello";}
    if($_SESSION["dateformat"] == 2){           // format = mm/dd/yyyy
        $x = 0; $y = 1; $z = 2;
    }elseif($_SESSION["dateformat"] == 6){      // format = dd/mm/yyyy
        $x = 1; $y = 0; $z = 2;
    }elseif($_SESSION["dateformat"] == 10){     // format = yyyy/mm/dd
        $x = 1; $y = 2; $z = 0;
    }
    if($gm == 1){
        $ldate = gmmktime($hour, $min, $sec, $arr_date[$x], $arr_date[$y], $arr_date[$z]) + $offset;
    }else{
        $ldate = mktime($hour, $min, $sec, $arr_date[$x], $arr_date[$y], $arr_date[$z]) + $offset;
    }        
    return($ldate);
}

function formatsec2str($databsecs,$dec)
{ 
    if($databsecs == -1){$databsecs = 0;}
    if(substr($databsecs ,0, 1) == '-'){$neg='-';$databsecs = $databsecs * -1;} else{$neg='';}
    $hours = intval($databsecs / 3600);
    if($dec == 1){        
        $min = round((($databsecs % 3600) / 36),0);
        if($min > 9){
            if(strlen($min) == 1){$min = trim($min) ."0";}
        }else{
            if(strlen($min) == 1){$min = "0" .trim($min);}            
        }
        $strtime = trim($neg) .trim($hours) ."." .trim($min);            
    }else{        
        $min = intval(($databsecs % 3600) / 60);
        if(strlen($min) == 1){$min = "0" .trim($min);}
        $strtime = trim($neg) .trim($hours) .":" .trim($min);            
    }
    return($strtime);
}
?>